require "#{ENV["TM_SUPPORT_PATH"]}/lib/scriptmate"
require "pathname"

class PerlScript < UserScript
  def lang; "Perl" end
  def executable; @hashbang || ENV['TM_PERL'] || 'perl' end
  def args
    ["-I#{e_sh(Pathname.new(ENV['TM_BUNDLE_SUPPORT']) + "PerlMate")}",
     "-Mexception_handler"]
  end
  def version_string
    %x{#{executable} -e 'printf "Perl v%vd", $^V'} + " (" + \
          %x{#{executable} -e 'use Config; print "$Config{perlpath}";'} + ")"
  end
end

class PerlMate < ScriptMate
  def filter_stderr(str)
    return "<div id='error_report' class='framed' style='color:red'>\n" + ( str.map do |line|
      line =~ /at (.*?) line.*?(\d+)/
      file, ln = $1, $2
      line = htmlize(line)
      line = line.gsub(/at (.*?).*?line (.*)/, '')
      if (file==nil) then
        "<p id='error'><strong>#{line}</strong></p>\n"
      else
        url = (file=="-") ? "" : "url=file://#{file}&amp;"
        display_name = (file=="-") ? "untitled" : File.basename(file)
        "<p id='error'><strong>#{line}</strong></p>\n<blockquote><table border='0' cellspacing='0' cellpadding='0'>\n"+
        "<tr style='font-size:9pt'><td>in <a class='near' href=\"txmt://open?#{url}line=#{ln}\"><strong>#{display_name}</strong></a> line #{ln}<td></tr></table></blockquote>\n"
      end
    end.join ) + "</div>"
  end
  def filter_stdout(str)
      return "<div style='border-bottom: 1px dotted #666;border-top: 1px dotted #666;'><br />" + htmlize(str) + "<br /></div>"
  end
end

script = PerlScript.new(STDIN.read)
PerlMate.new(script).emit_html